力扣HOT100之矩阵:73. 矩阵置零

这道题我没有想到什么好的办法,直接暴力AC了,直接遍历两次矩阵,第一次遍历用两个向量分别记录出现0的行数和列数,第二次遍历就判断当前的元素的行数或者列数是否出现在之前的两个向量中,若出现了就直接置零,否则就跳过。后面看了下空间复杂度为O(1)的解法,感觉这个思路不错,记录一下。

我们可以将第0行和第0列作为记录的标志位,例如matrix[5][6] == 0,我们就将matrix[0][6]和matrix[5][0]置为0,经过一次遍历后,除了第0行和第0列的情况没有统计出来,其余的行和列都已经遍历结束并且打上标签,由于打标签会向第0行和第0列添加0,打完标签后无法判断其本身原本就包含0,因此在遍历矩阵打标签之前,我们需要遍历矩阵的第0行和第0列,如果他们本身就有0,我们就分别用两个变量记录下来,至此,我们先分别遍历了矩阵的第0行和第0列,再遍历了矩阵的其余行和列,这就遍历了一次矩阵,我们再遍历一次矩阵,从下标为1的行和列开始,对于matrixij,如果matrix[0][j] == 0或matrix[i][0] == 0,我们就直接将matrix[i][j]置零。遍历结束后,我们还需要对第0行和第0列进行处理,如果他们原本就包含0,则将整行或整列直接置零。这里依然是遍历两次数组,但是由于只进行了比较操作,而没有进行查找操作,程序耗时要比我之前暴力AC短得多。

下面分别是暴力AC代码(空间复杂度O(m + n))和空间复杂度O(1)的代码。

cpp 复制代码
//暴力代码
class Solution {
public:
    void setZeroes(vector<vector<int>>& matrix) {
        vector<int> row;
        vector<int> column;
        for(int i = 0; i < matrix.size(); ++i){
            for(int j = 0; j < matrix[i].size(); ++j){
                if(matrix[i][j] == 0){
                    row.emplace_back(i);
                    column.emplace_back(j);
                }
            }
        }
        for(int i = 0; i < matrix.size(); ++i){
            for(int j = 0; j < matrix[i].size(); ++j){
                if(find(row.begin(), row.end(), i) == row.end() 
                    && find(column.begin(), column.end(), j) == column.end())
                    continue;
                matrix[i][j] = 0;
            }
        }
    }
};
cpp 复制代码
//空间复杂度O(1)代码
class Solution {
public:
    void setZeroes(vector<vector<int>>& matrix) {
        bool row_flag0 = false;   //判断第0行有没有0
        bool column_flag0 = false;  //判断第0列有没有0
        //遍历第0行
        for(int i = 0; i < matrix[0].size(); ++i){
            if(matrix[0][i] == 0){
                row_flag0 = true;
                break;
            }
        }
        //遍历第0列
        for(int i = 0; i < matrix.size(); ++i){
            if(matrix[i][0] == 0){
                column_flag0 = true;
                break;
            }
        }
        //遍历整个矩阵,在第0行和第0列标记0元素的分布情况
        for(int i = 1; i < matrix.size(); ++i){
            for(int j = 1; j < matrix[i].size(); ++j){
                if(matrix[i][j] == 0){
                    matrix[i][0] = 0;  //在第0列的对应位置置零
                    matrix[0][j] = 0;  //在第0行的对应位置置零
                }
            }
        }
        //开始置零
        for(int i = 1; i < matrix.size(); ++i){
            for(int j = 1; j < matrix[i].size(); ++j){
                if(matrix[i][0] == 0 || matrix[0][j] == 0)
                    matrix[i][j] = 0;  
            }
        }
        //判断在打标记之前第0行本身有没有0
        if(row_flag0){
            for(int i = 0; i < matrix[0].size(); ++i)
                matrix[0][i] = 0;
        }
        //判断在打标记之前第0列本身有没有0
        if(column_flag0){
            for(int i = 0; i < matrix.size(); ++i)
                matrix[i][0] = 0;
        }
    }
};
相关推荐
飞Link8 小时前
什么是 AirSim?一文读懂无人机仿真平台
python·算法·无人机
一去不复返的通信er10 小时前
贪心算法-合并区间(LeetCode 56)
算法·leetcode·贪心算法
Shaoshing11 小时前
LeetCode100 49. 字母异位词分组
java·算法
YFJ_mily11 小时前
第二届区块链技术与基础模型国际学术会议(BTFM2027)
算法·区块链·能源·智能系统·rdlink研发家·机器人自动化
汤姆宝库12 小时前
收官深拆:第一性原理、产业电网与未来推演
大数据·人工智能·算法
moshuying14 小时前
块扩散 + GDN 改造:Clover 把「并行生成」塞进了 Agent 的长上下文里
前端·算法
没落之王14 小时前
历史系统建模:宋初太祖太宗「再立天庭」秩序重构推演
人工智能·算法·重构
INGNIGHT14 小时前
91 · 最小调整代价(序列dp)
数据结构·算法·leetcode
moshuying14 小时前
扩散模型开始写代码、开网页了:350 亿参数,速度比 Jev 快一倍
前端·算法